var processor = new Object();
processor.Count = miniStatCore.getProcessorCount();
if ( !processor.Count ) processor.Count = 1;

var pFULLINFO = 0;
var pLIGHTINFO = 1;
var isProcessesSheetShown = false;					
var drawProcessesTableOnce = false;		

var memory = new Object();
var mSWAPDELAY = 6;						
var mFIRSTUPDATE = true;


var storage = [ { Label: 'Unknown0', TotalSize:  0, FreeSize:  0 }, 				
						{ Label: 'Unknown1', TotalSize:  0, FreeSize:  0 },
						{ Label: 'Unknown2', TotalSize:  0, FreeSize:  0 },
						{ Label: 'Unknown3', TotalSize:  0, FreeSize:  0 } ];
						
var disksCount = 0;
var currentSummaryDisk = [ 0, 0, 0, 0, 0, 0 ];

var sensors = [ 0, 0, 0, 0, 0 ];
var sCPU = 1;
var sCPU1 = 1;
var sCPUFULL1 = 2;
var sCPUPIC1 = 3;
var sCPU2 = 4;
var sCPUFULL2 = 5;
var sCPUPIC2 = 6;
var sBATTERY = 7;
var sDRIVE = 8;
var sFANSPEED = 9;
var sCPU1COLOR1 = 10;
var sCPU1COLOR2 = 11;

var sUPDATE_ALL = 1;
var sUPDATE_ONLYCPU = 0;
var sFIRSTUPDATE = true;

var currentSensorsView = 0;

var tb = 1073741824*1024;

var unitType = widget.preferenceForKey("unitType") || 'C';

var intefCount = 0;
							
var network = { Name: '---', InBytes:  0, OutBytes:  0, InSpeed:  0, OutSpeed:  0 };

var nts = {
			counterDown: 0,
			counterUp: 0,
			time: 0,
			intefDown: 0,	
			intefUp: 0 };
			
var currentCountersType = 1;
var resetDay = 1;

var CNT_DEFAULT = 1;
var CNT_DAILY = 2;
var CNT_WEEKLY = 3;
var CNT_MONTHLY = 4;
var CNT_MANUAL = 5;
var CNT_MONTHLY2 = 6;
						 
var int_IP = '';
var ext_ip = '';

var airport = { Installed: false, Power: false, Signal: 0, Network: "" };
var bluetooth = { Installed: false, Power: false, Discoverable: false, Connections: 0 };
						 
var monitorWhatNetwork = 'en0';
var currentInterfaceAtSummary = monitorWhatNetwork;
var currentNetworkViewType = 0;
						 
var bUNKNOWN = 0;
var bRUNNING = 1;
var bCHARGING = 2;
var bCHARGED = 3;

var firstCheckBattery = true;

var objs = new Object();

var req;

var battery = { Percentage:  0, Status:  0, Time:  0, Cycles:  0, AppleMouse: 0, AppleKeyboard: 0, LifeState: 0, Voltage: 0 };

var uptimer = null;
var timestamper = null;
var growler = null;

var timestampCounter = 20;

var updateWhatInfo = 'all';

var uMAX_PROCESSOR = 1;
var uMAX_PROCESSESLIST = 2;
var uMAX_MEMORY = 4;
var uMAX_STORAGE = 4;
var uMAX_NETWORK = 1;
var uMAX_SENSORS = 5;
var uMAX_BATTERY = 8;
var uMAX_HIDCHARGES = 29;

var updatesProcessor = uMAX_PROCESSOR;
var updatesProcessesList = uMAX_PROCESSESLIST;
var updatesMemory = uMAX_MEMORY;
var updatesStorage = uMAX_STORAGE;
var updatesNetwork = uMAX_NETWORK;
var updatesSensors = uMAX_SENSORS;
var updatesBattery = uMAX_BATTERY;
var updatesHIDCharges = uMAX_HIDCHARGES;

var updateNeed = new Array(6);
updateNeed['processor'] = false;
updateNeed['memory'] = false;
updateNeed['storage'] = false;
updateNeed['sensors'] = false;
updateNeed['network'] = false;
updateNeed['battery'] = false;

var lastResultProcessor = [ 0 ];
var lastResultMemory = [ 0 ];
var lastResultStorage = [ 0 ];
var lastResultNetwork = [ 0 ];
var lastResultSensors = [ 0 ];
var lastResultBattery = [ 0 ];

var CSL = 0;
var sectionsConfiguration = [ 
		[ 0, 6, 11, 13, 15, 19 ],
		[ 1, 7, 12, 14, 16, 20 ]
	];

var skipSetHint = false;
	
var sectionIcons = new Array(6);
var sectionValues = new Array(6);
var resetUpdateNeed = new Array(6);
var infoTypesToReset = { processor: false, memory: false, sensors: false, storage: false, network: false, battery: false };



function changeNetworkInterface(value) { monitorWhatNetwork = value; }
function changeResetDay(day) { resetDay = day; }
function changeTrafficResetType(value)
{
		var newValue = parseInt(value);
		if ( currentCountersType == CNT_DEFAULT && newValue != currentCountersType )
			{
					nts.counterDown = network.InBytes;
					nts.counterUp = network.OutBytes;
					var rightNow = new Date();
					nts.time = rightNow.getTime();
			}
		currentCountersType = newValue;
}

function autoSwitchInterfaceToTheMostActiveOne()
{
	
	var maxTrafInterface = getIntefWithMaxTraffic();
	
	if ( maxTrafInterface != monitorWhatNetwork )
	 {
	 	var currentInterfaceData = miniStatCore.updateNetwork_(monitorWhatNetwork);
		var maxTrafInterfaceData = miniStatCore.updateNetwork_(maxTrafInterface);
		
		if ( maxTrafInterfaceData[1] + maxTrafInterfaceData[2] >
			 (currentInterfaceData[1] + currentInterfaceData[2])*7 )
			 {
			 	setOption('network-interface',maxTrafInterface);
				changeNetworkInterface(maxTrafInterface);
			 }
	 }
}

function getIntefWithMaxTraffic()
{
	var intefCount = 0; 
	var infoList = miniStatCore.updateNetwork_("0");		
	if ( infoList ) intefCount = infoList.length;	
	
	var tempMax = -1;
	var foundInterfaceName = "en0";
	for(var i=0;i<intefCount;i++) 
		{
			var tempValue = infoList[i][1] + infoList[i][2];
			if ( tempValue > tempMax ) { tempMax = tempValue; foundInterfaceName =  infoList[i][0]; }
		}
	return foundInterfaceName;
}

function updateTimestampBG()
{
	updateNetworkValues(true);
	updateTimestamp(true);
}

function updateNetworkValues(unused)
{
	lastResultNetwork = miniStatCore.updateNetwork_(monitorWhatNetwork);	
	updatesNetwork = 0;

	if ( lastResultNetwork ) 
		{
			if ( lastResultNetwork[0] != monitorWhatNetwork ) 
				resetInterface(lastResultNetwork[0]);					
			intefCount = lastResultNetwork.length;
						
			if ( lastResultNetwork[0] )
				network.Name = lastResultNetwork[0];
												
			switch ( currentCountersType )
				{
					case CNT_DAILY:
					case CNT_MONTHLY:
					case CNT_WEEKLY:
					case CNT_MANUAL:
					case CNT_MONTHLY2:
						if ( lastResultNetwork[1] < nts.intefDown )
							nts.intefDown = lastResultNetwork[1];						
						if ( lastResultNetwork[2] < nts.intefUp )
							nts.intefUp = lastResultNetwork[2];							
						network.InBytes = nts.counterDown+(lastResultNetwork[1]-nts.intefDown);
						network.OutBytes = nts.counterUp+(lastResultNetwork[2]-nts.intefUp);
						break;
					default:
						network.InBytes = lastResultNetwork[1];
						network.OutBytes = lastResultNetwork[2];			
				}
				
			network.InSpeed = lastResultNetwork[3];
			network.OutSpeed= lastResultNetwork[4];			
		}
}

function setCounterValuesForPrefs(absolute)
{
	if ( absolute )
		{
			n = formatNumber(network.InBytes*1024);
			o('counterSumm_in').innerText = n.num+n.type;
			n = formatNumber(network.OutBytes*1024);
			o('counterSumm_out').innerText = n.num+n.type;		
		}
	else
		{
			o('counterSumm_in').innerText = "?? B";
			o('counterSumm_out').innerText = "?? B";	
			if ( currentNetworkViewType != 2 ) o('netwSumValue').innerText = "?? B";
		}
}

function restoreCounters()
{
	nts.counterDown = getOption('counter-down');
	nts.counterUp = getOption('counter-up');	
	nts.time = getOption('counter-timestamp');		
	
	var netw = miniStatCore.updateNetwork_(monitorWhatNetwork);	
	
	if ( !netw ) return;	
	if ( netw[0] != monitorWhatNetwork ) // autoSwitchInterfaceToTheMostActiveOne();
			resetInterface(netw[0]);		

	nts.intefDown = netw[1];
	nts.intefUp = netw[2];	
	
}

function updateTimestamp(flush)
{

	if ( currentCountersType == CNT_DEFAULT ) return;

	var rightNow = new Date();
	var lastTime = new Date();
	lastTime.setTime(nts.time);	
	
	switch(currentCountersType)
		{
			case CNT_DAILY:
				if ( lastTime.getDay() != rightNow.getDay() ) resetTrafficCounters(true);
				break;
			case CNT_WEEKLY:
				if ( (lastTime.getDay()==6||lastTime.getDay()==0)  && (rightNow.getDay()==1||rightNow.getDay()==2)) resetTrafficCounters(true);				
				break;		
			case CNT_MONTHLY:
				if ( lastTime.getMonth() != rightNow.getMonth()  ) resetTrafficCounters(true);	
				break;
			case CNT_MONTHLY2:
				if ( lastTime.getDate() != resetDay && rightNow.getDate() == resetDay ) resetTrafficCounters(true);	
				break;						
		}

	var netw = miniStatCore.updateNetwork_(monitorWhatNetwork);	
	
	if ( !netw ) return;
	if ( netw[0] != monitorWhatNetwork )/// autoSwitchInterfaceToTheMostActiveOne();
			resetInterface(netw[0]);		
	if (netw[1] < nts.intefDown )
		nts.intefDown = netw[1];							
	if ( netw[2] < nts.intefUp )
		nts.intefUp = netw[2];	
		
	nts.counterDown = nts.counterDown+(netw[1]-nts.intefDown);
	nts.counterUp = nts.counterUp+(netw[2]-nts.intefUp);

	nts.intefDown = netw[1];
	nts.intefUp = netw[2];	
	nts.time = rightNow.getTime();
	
	if ( flush && !miniStatCore.isUserIdle() ) flushTimestamp();		
}

function flushTimestamp()
{
	setOption('counter-down',network.InBytes);
	setOption('counter-up',network.OutBytes);		
	setOption('counter-timestamp',nts.time);	
}

function resetTrafficCounters(absolutely)
{
	var saveCounterUp = 0;
	var saveCounterDown = 0;
	
	var rightNow = new Date();	
	nts.time = rightNow.getTime();
	
	var netw = miniStatCore.updateNetwork_(monitorWhatNetwork);	
	
	if ( !netw ) return;	
	if ( netw[0] != monitorWhatNetwork ) //autoSwitchInterfaceToTheMostActiveOne();
			resetInterface(netw[0]);		

	nts.intefDown = netw[1];
	nts.intefUp = netw[2];	
			
	if ( currentCountersType != CNT_MANUAL && !absolutely )
		{
			saveCounterUp = nts.counterUp;
			saveCounterDown = nts.counterDown;	
			nts.counterDown = netw[1];
			nts.counterUp = netw[2];	
		}
	else
		{
			nts.counterDown = nts.counterUp = 0;
			saveCounterDown = network.InBytes;
			saveCounterUp = network.OutBytes;			
		}
	
	if ( absolutely )
		{
			var addStrReason = "Manual reset";
			
			switch ( currentCountersType )
				{
					case CNT_MONTHLY:
						addStrReason = "New month"; break;
					case CNT_MONTHLY2:
						addStrReason = "New month (Day="+resetDay+")"; break;
					case CNT_WEEKLY:
						addStrReason = "New week"; break;					
					case CNT_DAILY:
						addStrReason = "New day"; break;			
				}
			
			var yy = formatNumber(saveCounterDown*1024);
			var bb = formatNumber(saveCounterUp*1024);
			
			var compString = yy.num+yy.type+' (Download) / '+bb.num+bb.type+' (Upload)';
			miniStatCore.writeToLog_openLogFile_('Resetting traffic counters for "'+monitorWhatNetwork+'" connection. Reason: '+addStrReason+'. Last values are: ' +compString,false);
			
			if ( currentCountersType != CNT_MANUAL && notificationTypes[3].enabled ) miniStatCore.postGrowlNotify_ofType_withExtra_('Traffic counters in miniStat2 have been reset. Previous values: '+(yy.num+yy.type)+'↓ / '+(bb.num+bb.type)+'↑',4,addStrReason);
		}
}

function changeTimes(what,newValue)
{
	var value = parseInt(newValue);
	if ( !value ) value = 3;
	switch(what)
		{
			case 'processor': uMAX_PROCESSOR = value; break;
			case 'memory': uMAX_MEMORY = value; break;
			case 'storage': uMAX_STORAGE = value; break;
			case 'network': uMAX_NETWORK = value; break;
			case 'sensors': uMAX_SENSORS = value; break;
			case 'battery': uMAX_BATTERY = value; break;		
		}
}



function restoreSavedStates()
{
	
	uMAX_PROCESSOR = getOption('update-processor') || uMAX_PROCESSOR;
	uMAX_MEMORY = getOption('update-memory') || uMAX_MEMORY;
	uMAX_STORAGE = getOption('update-storage') || uMAX_STORAGE;
	uMAX_SENSORS = getOption('update-sensors') || uMAX_SENSORS;
	uMAX_NETWORK = getOption('update-network') || uMAX_NETWORK;
	uMAX_BATTERY = getOption('update-battery') || uMAX_BATTERY;
}

function resetUpdateCounters()
{
	updatesProcessor = uMAX_PROCESSOR;
	updatesMemory = uMAX_MEMORY;
	updatesStorage = uMAX_STORAGE;
	updatesNetwork = uMAX_NETWORK;
	updatesSensors = uMAX_SENSORS;
	updatesBattery = uMAX_BATTERY;
	updatesHIDCharges = uMAX_HIDCHARGES;
	mSWAPDELAY = 6;
}



function disableUpdateTimer()
{
	if (uptimer == null) return;
	clearInterval(uptimer);
	uptimer = null;
	if ( timestamper == null ) { timestamper = setInterval('updateTimestampBG()',30000); }
	if ( growler == null && parseInt(getOption('growl-mode'))) { growler = setInterval('fireGrowlUpdate()',(parseInt(getOption('growl-interval'))*1000)||15000); }
}

function setUpdateWhatInfo(what)
{
	updateWhatInfo = what;
}

function r(x)
{
	return Math.round(Math.random()*x);
}

function updateProcessor(forSummary)
{
	var result = miniStatCore.updateProcessor_( forSummary ? pLIGHTINFO : pFULLINFO);
	processor.OverallUsage = result[0];
	processor.OverallUsage1 = result[1];
	processor.OverallUsage2 = result[2];						
	processor.Load  = result[7];
	processor.UsageUser = result[3];							
	processor.UsageSystem = result[4];
	processor.firstProcBar = result[5];
	processor.secondProcBar = result[6];
	processor.Uptime = result[8];
	processor.UptimeFull = result[9];	
	processor.Frequency = result[10];		
	updateNeed['processor'] = true;
}

function updateSensors(forSummary)
{
	var sFanSectionExists = false;
	for(var x in sectionsConfiguration[CSL])
		if (sectionsConfiguration[CSL][x] == 12) { sFanSectionExists = true; break; }
	
	var result = miniStatCore.updateSensors_andFans_(unitType=='C'?0:1,  (!forSummary||sFIRSTUPDATE||sFanSectionExists)?true:false );

	if ( sFIRSTUPDATE ) sFIRSTUPDATE = false;
	sensors[sCPU1] = result[0];
	sensors[sCPUFULL1] = result[1];				
	sensors[sCPUPIC1] = result[2];
	sensors[sCPU2] = result[3];
	sensors[sCPUFULL2] = result[4];								
	sensors[sCPUPIC2] = result[5];			
	sensors[sBATTERY] = result[6];
	sensors[sDRIVE] = result[7];				
	sensors[sFANSPEED] =  result[8];			
	sensors[sCPU1COLOR1] = result[9];
	sensors[sCPU1COLOR2] = result[10];	
	updateNeed['sensors'] = true;
}

function updateMemory(forSummary)
{
	var result = miniStatCore.updateMemory_( mFIRSTUPDATE ? false: !forSummary );
	if ( mFIRSTUPDATE ) mFIRSTUPDATE = false;
	memory.Free = result[0];
	memory.Used = result[1];
	memory.Wired = result[3];
	memory.Inactive = result[2];
	memory.Swap = result[4];
	memory.bar1 = result[5];
	memory.bar2 = result[6];
	memory.bar3 = result[7];
	memory.bar4 = result[8];
	memory.bar5 = result[9];	
	memory.ratio = result[10];		
	updateNeed['memory'] = true;
}

function updateStorage(forSummary)
{	
	var result = miniStatCore.updateStorage();	
	disksCount = result.length;		
	if ( disksCount > 4 ) disksCount = 4;
	var i; var tempDisksCount = 0;
	for(i=0; i<=3; i++) { storage[i].Label = 'Unknown'+i; storage[i].TotalSize = 0; storage[i].FreeSize = 0; }
	for(i=0; i<=disksCount-1; i++) 
		{
			if ( result[i][2] < 3000  ) continue;			
				storage[tempDisksCount].Label = result[i][0];
				storage[tempDisksCount].TotalSize = result[i][2];
				storage[tempDisksCount].FreeSize = result[i][1];
				storage[tempDisksCount].FreeStr = result[i][3];				
				storage[tempDisksCount].UsedStr = result[i][4];								
				storage[tempDisksCount].BarWidth = result[i][5];																						
				tempDisksCount++;
		}
	disksCount = tempDisksCount;
	updateNeed['storage'] = true;
}

function updateNetwork(forSummary)
{
	updateNetworkValues(true);	
						
	timestampCounter++;
	if ( timestampCounter > 20 )
		{
			timestampCounter = 0;
			updateTimestamp(true);
		}
		
	var thereIsAirportInSummary = false;	
	for (var sect in sectionsConfiguration[CSL])
		if ( sectionsConfiguration[CSL][sect] == 18 ) thereIsAirportInSummary = true;
		
		
	if ( !forSummary || thereIsAirportInSummary )
		{
			var resultAirport = miniStatCore.updateAirport();
			var resultBluetooth = miniStatCore.updateBluetooth();
			
			airport.Installed = resultAirport[0];
			airport.Power = resultAirport[1];
			airport.Signal = resultAirport[2];
			airport.Network = resultAirport[3];
						
			bluetooth.Installed = resultBluetooth[0];
			bluetooth.Power = resultBluetooth[1];						
			bluetooth.Discoverable = resultBluetooth[2];
			bluetooth.Connections = resultBluetooth[3];								
		}	
	updateNeed['network'] = true;
}

function updateBattery(forSummary)
{
	var result = miniStatCore.updateBattery();	
	battery.Percentage =  result[0];
	battery.Time =    result[2];
	battery.Status =  result[1];
	battery.Cycles =   result[3];
	battery.LifeState =  result[4];
	battery.AppleMouse =  result[5];
	battery.AppleKeyboard = result[6];
	battery.Voltage = result[7];	
	updateNeed['battery'] = true;
}

function updateInfo()
{	
	var updateAll = false;
//	regKeyPress(0); 
	
	switch(updateWhatInfo)
		{
			case 'all':
				updateAll = true;
			case 'processor': if ( ++updatesProcessor >= uMAX_PROCESSOR ) { updateProcessor(updateAll); updatesProcessor=0; }
							  if ( !updateAll && ++updatesProcessesList >= uMAX_PROCESSESLIST ) { updateProcessesList(); updatesProcessesList=0; }
			case 'sensors':	if ( ++updatesSensors >= uMAX_SENSORS ) { updateSensors(updateAll); updatesSensors=0; }
				if ( !updateAll ) break;				
			case 'memory':	if ( ++updatesMemory >= uMAX_MEMORY ) { updateMemory(updateAll); updatesMemory=0; }
				if ( !updateAll ) break;
			case 'storage':	if ( ++updatesStorage >= uMAX_STORAGE ) { updateStorage(updateAll); updatesStorage=0; }
				if ( !updateAll ) break;
			case 'network':	if ( ++updatesNetwork >= uMAX_NETWORK ) { updateNetwork(updateAll); updatesNetwork=0; }
				if ( !updateAll ) break;
			case 'battery':	if ( ++updatesBattery >= uMAX_BATTERY ) { updateBattery(updateAll); updatesBattery=0; }
				if ( !updateAll ) break;
		}
	drawInfo();
}

function setupUpdateTimer()
{
	if (uptimer == null) 
		{
			uptimer = setInterval(updateInfo,1050);					
			if ( timestamper != null ) { clearInterval(timestamper); timestamper = null; }
			if ( growler != null ) { clearInterval(growler); growler = null; }
		}
	updateInfo();
}

function updateProcessesList()
{
	var sortKey = getOption('processes-list-sort');
	if ( !sortKey || (sortKey != 'r' && sortKey != 'm') ) sortKey = 'r';
	miniStatCore.askForProcessesListWithSort_(sortKey);
}

function drawInfo()
{
	switch ( updateWhatInfo )
		{
			case 'all':
				for (var sect in sectionsConfiguration[CSL])
					{
						var type = parseInt(sectionsConfiguration[CSL][sect]);
						if ( !updateNeed[sectionTypes[type].type] )  continue; 
						infoTypesToReset[sectionTypes[type].type] = true;						
						var icon = sectionIcons[sect];
						var value = sectionValues[sect];
						
						icon.src = "Icons/"+sectionTypes[type].icon;	

						switch ( type )
							{
								case 00: value.innerText = processor.OverallUsage;	break;
								case 01: value.innerText = processor.OverallUsage1;	break;
								case 02: value.innerText = processor.OverallUsage2;	break;
								case 03: value.innerText = processor.Uptime; break;	
								case 04: value.innerText = processor.Load;	break;			
								case 05: value.innerText = processor.Frequency; break;
								case 06: value.innerText = memory.Free;	break;	
								case 07: value.innerText = memory.Used;	break;	
								case 08: value.innerText = memory.Inactive;	break;	
								case 09: value.innerText = memory.Wired; break;	
								case 10: value.innerText = memory.ratio; break;									
								case 11:
									if ( !storage[currentSummaryDisk[sect]].TotalSize ) currentSummaryDisk[sect] = 0;
									value.innerText = storage[currentSummaryDisk[sect]].FreeStr;
									
									if ( getOption('disk-icons') )
									 {
										var iconFile = miniStatCore.pathToDiskIcon_( storage[currentSummaryDisk[sect]].Label );																	if ( iconFile != 'x' ) icon.src = iconFile;
									 }
									 								
									break;
								case 12: 	
									value.innerHTML = sensors[currentSensorsView*3+1];
									icon.src = sensors[sCPUPIC1+currentSensorsView*3];
									break;
								case 13: value.innerHTML = sensors[sFANSPEED]; break;
								case 14: 
									var n = formatNumber(network.InBytes*1024); 
									value.innerText = n.num+n.type;	
									break;
								case 15: 
									var n = formatNumber(network.OutBytes*1024); 
									value.innerText = n.num+n.type;	
									break;
								case 16:
									var n = formatNumber(network.InSpeed); 
									var m = formatNumber(network.OutSpeed);
									value.innerHTML = n.num+" "+n.type+"/s<br/>"+m.num+" "+m.type+"/s";	
									break;
								case 17: 
									var n = formatNumber((network.OutBytes+network.InBytes)*1024); 
									value.innerText = n.num+n.type;	
									break;
								break;
								case 18: value.innerHTML = airport.Signal > 1 ? d(airport.Signal) + "%" : "------"; break;								
								case 19:
									value.innerText = battery.Percentage==100 ? "100%" : getOneAfterDot(battery.Percentage)+"%";
									if ( battery.Percentage < 30.0 ) icon.src = 'Icons/BatteryWarning.png';
									break;
								case 20: value.innerText = battery.Time; break;
								case 21: value.innerText = battery.Cycles; break;
								case 22: value.innerText = d(battery.AppleMouse)+"%"; break;								
								case 23: value.innerText = d(battery.AppleKeyboard)+"%"; break;																
						} 
					}
					
				for(var x in infoTypesToReset)
					{ if (infoTypesToReset[x]) updateNeed[x] = false; infoTypesToReset[x] = false; }
				break;
				
			default:
				var triggerStr = updateWhatInfo.substring(0,1).toUpperCase()+updateWhatInfo.substring(1,updateWhatInfo.length);
				eval("if ( updateNeed['"+updateWhatInfo+"'] ) { draw"+triggerStr+"(); updateNeed['"+updateWhatInfo+"'] = false; }");
				break;
			
		}
			
}

function changeSectionsLayout(a,b,c,d,e,f)
{	
	changeOneSection(1,a); changeOneSection(2,b); changeOneSection(3,c); changeOneSection(4,d); changeOneSection(5,e); changeOneSection(6,f);		
}

function changeOneSection(numx,value)
{
	var num = numx-1;
	var defaultTops = [ 8, 34, 60, 8, 34, 60 ];
	var defaultLefts = [ 29, 29, 29, 73, 73, 73 ];
	sectionsConfiguration[CSL][num] = parseInt(value);
	
	sectionValues[num].style.top = defaultTops[num]+"px";
	sectionValues[num].style.fontSize = "12px";
	sectionValues[num].style.left = defaultLefts[num]+"px";	
	
	switch ( sectionsConfiguration[CSL][num] ) 
		{
			case 05:
				sectionValues[num].style.left = (defaultLefts[num]+(num>2?3:-2))+"px";
				break;			
			case 11: //storage
				currentSummaryDisk[num] = parseInt(getOption('section-extra'+(num+1)));
				break;
			case 16: //network bandwidth
				sectionValues[num].style.fontSize = "10px";
				sectionValues[num].style.top = (defaultTops[num]-((num==0||num==3)?2:4))+"px";
				sectionValues[num].style.left = (defaultLefts[num]+(num>2?3:-2))+"px";
				break;
			case 19:
			case 22: //battery percents
			case 23:
				sectionValues[num].style.left = (defaultLefts[num]+(num>2?2:-1))+"px";				
				break;

		}
}

function drawProcessor()
{
	if (processor.Count == 2)
		{
			o('firstProcBar').src = processor.firstProcBar;
			o('secondProcBar').src = processor.secondProcBar;	
			o('firstProcTemp').style.backgroundColor = sensors[sCPU1COLOR1];						
			o('firstProcTemp').innerHTML = sensors[sCPU1];					
			o('secondProcTemp').style.backgroundColor = sensors[sCPU1COLOR2];	
			o('secondProcTemp').innerHTML = sensors[sCPU2];
		}
	else if (processor.Count == 1)
		{
			o('oneProcBar').src = processor.firstProcBar;	
			o('oneProcTemp').style.backgroundColor = sensors[sCPU1COLOR1];						
			o('oneProcTemp').innerHTML = sensors[sCPU1];
		}		
		
	o('usageUser').innerText = processor.UsageUser;
	o('usageSystem').innerText = processor.UsageSystem;
	o('usageNice').innerText = processor.Load;
		
	if ( parseInt(processor.Load) > 1.00 )
		o('usageNice').style.color = 'darkred';
	else
		o('usageNice').style.color = 'black';
			
	o('uptimeValue').innerHTML = processor.UptimeFull;	
}

function drawMemory()
{	
	o('activeMemory').innerText = memory.Used;
	o('inactiveMemory').innerText = memory.Inactive;
	o('wiredMemory').innerText = memory.Wired;
	o('freeMemory').innerText = memory.Free;
				
	o('swapValue').innerText = memory.Swap;
				
	o('viewMemActive').style.width = memory.bar1;
	o('viewMemWired').style.width = memory.bar2;
	o('viewMemWired').style.left = memory.bar3;
	o('viewMemInactive').style.width = memory.bar4;
	o('viewMemInactive').style.left = memory.bar5;
}

function drawStorage()
{
	if ( disksCount <= 2 )
		{
			o('windowStorage').setAttribute('class','mainWindow storage12');		
			if ( disksCount == 2 )
			 {
				o('storageContent').style.backgroundImage = "url(Images/StorageSeps2.png)";
			 }
			else // ( == 1 )
				o('storageContent').style.background = "none";		
				
			o('storageContent').style.height = "72px";					
		}
	else
		{
			o('windowStorage').setAttribute('class','mainWindow storage34');
			o('storageContent').style.backgroundImage = "url(Images/StorageSeps4.png)";
			if ( disksCount == 3 )
				o('storageContent').style.height = "48px";
			else // == 4
				o('storageContent').style.height = "72px"; 
		}
				
	for(var i=0; i<=3; i++)
		{
			var show = 'block';
			if (disksCount-1 < i) show = 'none';
			o('storageRow'+(i+1)).style.display = show;
			
			if ( i>disksCount-1 ) o('HDIcon'+(i+1)).src = "Images/transparent.png";
		}
		
	for(var i=0; i<=disksCount-1; i++)
		{
			if ( i < 2 && disksCount <= 2 )
			 {
			 	o('diskLabel'+(i+1)).style.display = "block";
				o('diskLabel'+(i+1)).innerHTML = "<nobr>"+storage[i].Label.replace(/\s/g,'&nbsp;')+"</nobr>";
			 }
			else if ( disksCount > 2 )
			{
				o('diskLabel'+(i+1)).style.display = "none";
			}	
			
			o('viewStorageUsed'+(i+1)).style.width = storage[i].BarWidth;
			
			var usageColor = clamp(Math.round(storage[i].BarWidth/10.0),1,5) - 1;
			
			
			o('viewStorageUsed'+(i+1)).style.backgroundImage = "url(Images/StorageUsed"+usageColor+".png)";
			
			o('diskFreeSummary'+(i+1)).innerText = storage[i].FreeStr;
						

//			o('diskUsedSummary'+(i+1)).innerText = storage[i].UsedStr;
								
												
			var iconFile = miniStatCore.pathToDiskIcon_( storage[i].Label );
						
			if ( iconFile != 'x' ) 
				o('HDIcon'+(i+1)).src = iconFile;
			else
				o('HDIcon'+(i+1)).src = "Images/transparent.png";
		
		


		}
}

function drawSensors()
{
	if ( processor.Count == 2 )
		{
			o('cpuASensorValue').style.backgroundColor = sensors[sCPU1COLOR1];
			o('cpuASensorValue').innerHTML = sensors[sCPUFULL1];
			o('cpuBSensorValue').style.backgroundColor = sensors[sCPU1COLOR2];
			o('cpuBSensorValue').innerHTML = sensors[sCPUFULL2];
		}
	else
		{
			o('cpuOneSensorValue').style.backgroundColor = sensors[sCPU1COLOR1];
			o('cpuOneSensorValue').innerHTML = sensors[sCPUFULL1];
		}		
	
	var showBatSens = 'none';
	if ( sensors[sBATTERY]  &&  sensors[sBATTERY] != "0" && battery.Status ) 
		 {
			showBatSens = 'block';
			o('sensBatteryIcon').src = "Icons/Battery.png";
			o('sensBatteryLabel').innerText = I18N_SENSORS_BATTERY;
			o('sensBatteryLabel').style.left = "14px";
			o('batterySensorValue').setAttribute('class','yellowBackground');							 	
		 }
		 
	o('batterySensorValue').innerHTML = sensors[sBATTERY];
	o('sensorBatteryFrame').style.display = showBatSens;
				
	var showDriveSens = 'none';
	if ( sensors[sDRIVE] && sensors[sDRIVE] != "0" ) 
		{
			showDriveSens = 'block';
			o('sensDriveIcon').src = "Icons/Storage.png";
			o('sensDriveLabel').innerText = I18N_SENSORS_DRIVE;					 		
		}
		
	o('driveSensorValue').innerHTML = sensors[sDRIVE];
	o('sensorDriveFrame').style.display = showDriveSens;				
				
	if ( sensors[sFANSPEED] > 0 && showBatSens == 'none' )
		{
			o('sensBatteryIcon').src = 'Icons/Fan.png';
			o('batterySensorValue').innerHTML = sensors[sFANSPEED];
			o('sensorBatteryFrame').style.display = 'block';
			if ( I18N_SENSORS_FAN == "Fan" )
				o('sensBatteryLabel').innerHTML = 'Fan<img class="rpmIcon" src="Icons/rpm.png">';		
			else
				o('sensBatteryLabel').innerHTML = I18N_SENSORS_FAN;
				
			o('sensBatteryLabel').style.left = "16px";
		}
	else if ( sensors[sFANSPEED] > 0 && showDriveSens == 'none' )
		{
			o('sensDriveIcon').src = 'Icons/Fan.png';
			o('driveSensorValue').innerHTML = sensors[sFANSPEED];			
			o('sensorDriveFrame').style.display = 'block';
			if ( I18N_SENSORS_FAN == "Fan" )
				o('sensDriveLabel').innerHTML = 'Fan<img class="rpmIcon" src="Icons/rpm.png">';		
			else
				o('sensDriveLabel').innerHTML = I18N_SENSORS_FAN;						
		}
}

function drawNetwork()
{	
	n = formatNumber(network.InSpeed);
	o('inSpeed').innerHTML = n.num+" <span  class=\"speedType\">"+n.type+"/s</span>";
	o('inTrafIcon').style.opacity = n.num ? 1.0 : 0.3;
					
	n = formatNumber(network.OutSpeed);
	o('outSpeed').innerHTML = n.num+" <span  class=\"speedType\">"+n.type+"/s</span>";
	o('outTrafIcon').style.opacity = n.num ? 1.0 : 0.3;
				
	n = formatNumber(network.InBytes*1024);
	o('inTraffic').innerText = n.num+n.type;
	n = formatNumber(network.OutBytes*1024);
	o('outTraffic').innerText = n.num+n.type;		

	o('intefName').innerText = network.Name;
					
	if ( bluetooth.Installed && bluetooth.Power ) 
		o('bluetoothIcon').src = "Images/BluetoothON.png";
	else if ( bluetooth.Installed && !bluetooth.Power ) 
		o('bluetoothIcon').src = "Images/BluetoothOFF.png";
	else
		o('bluetoothIcon').src = "Images/BluetoothDISABLED.png";						

	o('bluetoothDiscoverable').style.opacity = bluetooth.Discoverable ? 1.0 : 0.4;	
	o('bluetoothConnections').innerText = bluetooth.Power ? bluetooth.Connections : '?';
	o('bluetoothConnections').style.opacity = bluetooth.Power ? 1.0 : 0.5;
					
	o('airportframe').style.opacity = airport.Installed ? 1.0 : 0.4;

	var airPowered = miniStatCore.powerAirport__(false,false);

	if ( airport.Signal > 0 )
		o('airportSignal').src = "Images/AirportBars/"+clamp(Math.round(airport.Signal*0.1),1,10)+".png";
	else if ( airPowered && airport.Signal == 0 )
		o('airportSignal').src = "Images/AirportBars/connected.png";
	else
	o('airportSignal').src = "Images/AirportBars/0.png";
						
	o('airportIcon').src = "Images/Airport"+(airPowered?"On":"Off")+".png";
			
	if ( airport.Network != "Unknown" )
		{	
			o('airportNetwork').style.color = "#222";						
			o('airportNetwork').innerText  = airport.Network;							
		}
	else
		{
			o('airportNetwork').style.color = "#777";
			o('airportNetwork').innerText  = getLocalizedString("No connection");		
		}
}

function drawBattery()
{
	o('battPercentage').innerText = battery.Percentage==100 ? "100%" : getOneAfterDot(battery.Percentage)+"%";
	var addstr = ' remaining';
	var prefstr = '';	
	switch(battery.Status)
		{
			case bUNKNOWN: o('battStatus').innerText = I18N_BATTERY_UNKNOWN; break;
			case bRUNNING: o('battStatus').innerText = I18N_BATTERY_RUNNING; break;
			case bCHARGED: o('battStatus').innerText = I18N_BATTERY_CHARGED; break;
			case bCHARGING: o('battStatus').innerText = I18N_BATTERY_CHARGING; addstr = I18N_BATTERY_UNTILFULL; break;
		}
		
	o('battVoltage').innerText = battery.Voltage + "V";
		
	var isThereAnyWireless = (battery.AppleMouse > 1 || battery.AppleKeyboard > 1);

	o('wirelessSwitch').setAttribute('class', isThereAnyWireless ? 'yesWireless' : 'noWireless' );
	o('battSeps').src="Images/BatterySeps"+( isThereAnyWireless ? "Wireless" : "" )+".png";	

	if ( battery.Time != "??:??" && battery.Status != bCHARGED ) 
		{	
			if (isThereAnyWireless) 
				{
					prefstr = I18N_BATTERY_TIME+': ';
					addstr = '';
				}		
			o('battTime').innerText = prefstr+battery.Time+addstr;
		}
	else if (  battery.Status == bCHARGED ) 
		o('battTime').innerText = isThereAnyWireless ? I18N_BATTERY_TIME+': --:--' : I18N_BATTERY_FULLYCHARGED
	else 
		o('battTime').innerText = isThereAnyWireless ? I18N_BATTERY_TIME+': ??:??' : I18N_BATTERY_CALCULATING;					

					
	if ( isThereAnyWireless )
		o('battCycles').innerText = I18N_BATTERY_CYCLES+': '+battery.Cycles;
	else
		{
			if ( battery.LifeState < 1 )
				 o('battCycles').innerText = battery.Cycles + " "+I18N_BATTERY_FULLCYCLES;
			else
				o('battCycles').innerText = I18N_BATTERY_CYCLES+': '+battery.Cycles + " | "+I18N_BATTERY_LIFE+": "+Math.round(battery.LifeState)+"%"; 
		}
				
	if ( battery.Percentage > 1)
		o('batteryWindowMainContent').setAttribute('class','mainContent');
				
	if ( isThereAnyWireless && battery.Percentage < 1)
		{
			o('batteryWindowMainContent').setAttribute('class','mainContent onlyWireless');
						
			o('firstIconHID').src ='Icons/WirelessMouse.png';				
			o('secondIconHID').src ='Icons/WirelessKeyboard.png';		
						
			o('mouseChargeText').innerText = battery.AppleMouse>1 ? d(battery.AppleMouse) + "%" : "? %";
			o('firstCharge').src = battery.AppleMouse>1 ? getHIDChargePic(battery.AppleMouse) : getHIDChargePic(100);
			o('firstHIDSection').style.opacity = battery.AppleMouse>1 ? 1.0 : 0.2;

			o('keyboardChargeText').innerText = battery.AppleKeyboard>1 ? d(battery.AppleKeyboard) + "%" : "? %";
			o('secondCharge').src = battery.AppleKeyboard>1 ? getHIDChargePic(battery.AppleKeyboard) : getHIDChargePic(100);;
			o('secondHIDSection').style.opacity = battery.AppleKeyboard>1 ? 1.0 : 0.2;

		}	
	else if ( isThereAnyWireless )
		{
			var keyboardIcon = 'Icons/WirelessKeyboard.png';
			var mouseIcon = 'Icons/WirelessMouse.png';						
			if ( battery.AppleMouse > 1 && battery.AppleKeyboard > 1 )
				{
					o('firstIconHID').src = mouseIcon;
					o('secondIconHID').src = keyboardIcon;
					o('firstCharge').src = getHIDChargePic(battery.AppleMouse);
					o('secondCharge').src = getHIDChargePic(battery.AppleKeyboard);
					o('HIDBlk').style.top = "0px";								
					firstChargeShow(true); secondChargeShow(true);
				}
			else if ( battery.AppleMouse < 1 && battery.AppleKeyboard > 1 )
				{
					o('firstIconHID').src = keyboardIcon;
					o('firstCharge').src = getHIDChargePic(battery.AppleKeyboard);
					o('HIDBlk').style.top = "10px";
					firstChargeShow(true); secondChargeShow(false);								
				}
			else if ( battery.AppleMouse > 1 && battery.AppleKeyboard < 1 )
				{
					o('firstIconHID').src = mouseIcon;
					o('firstCharge').src = getHIDChargePic(battery.AppleMouse);
					o('HIDBlk').style.top = "10px";
					firstChargeShow(true); secondChargeShow(false);
					}					
			else 
				{
					firstChargeShow(false); secondChargeShow(false);
					o('HIDBlk').style.top = "0px";
				}
		}
}

function clamp(num,min,max)
{
	if(num<min) num = min;
	if(num>max) num = max;
	return num;
}

function d(x) 
{ 
	if ( x == -256 ) 
		return "??";
	else
		return Math.round(x);
}

function getIPs()
{
	var ipResult = miniStatCore.getMainIPAddress();
	o('internalAddr').value = int_IP = ipResult[0];
	o('externalAddr').value = ext_IP = ipResult[1];
}

function changeUnit(unit) 
{
	unitType = unit;
	notificationTypes[2].extra = 'º'+unitType+' >';	
	if (window.widget){widget.setPreferenceForKey(unit, "unitType");}
}


function renderInfo()
{
return;

}

function firstChargeShow(what) {
	o('firstIconHID').style.display = what?'block':'none';
	o('firstCharge').style.display = what?'block':'none';
}

function secondChargeShow(what) {
	o('secondIconHID').style.display = what?'block':'none';
	o('secondCharge').style.display = what?'block':'none';
}

function toggleAirport()
{
	if ( miniStatCore.powerAirport__(false,false) )
		{
			miniStatCore.powerAirport__(true,false);
			o('airportIcon').src = "Images/AirportOff.png";
			o('airportNetwork').style.color = "#777";
			o('airportNetwork').innerText  = getLocalizedString("No connection");			
		}
	else
		{
			miniStatCore.powerAirport__(true,true);
			o('airportIcon').src = "Images/AirportOn.png";
		}
	
}


function getHIDChargePic(perc)
{
	return 'Images/WirelessBattery/'+clamp(Math.round(perc*0.07),1,7)+'.png';
}


function formatNumber(num)
{
	var result = new Object();
	var arrayRes = miniStatCore.formatNumber_(num);
	result.num = arrayRes[0];
	result.type = arrayRes[1];	
	return result;
}

function getOneAfterDot(xnum)
{
	if ( xnum == -256 ) return "??";
	return miniStatCore.getOneAfterDot_(xnum);
} 

function getBatteryUpdatedStatus()
{
	if ( battery.Status != bUNKNOWN || battery.AppleMouse > 1 || battery.AppleKeyboard > 1 ) return true;	
	return false;
}

function getBatteryStatus()
{
	var result = miniStatCore.updateBattery();

	var retVal = false;
	if ( result[1] ) retVal = true;	
	if ( result[5] > 1) { retVal = true; }
	if ( result[6] > 1) { retVal = true; }
 		
	return retVal;
}

function rotateSectionType(whatType)
{
	var rotatesCount = 0;
	for ( var sect in sectionsConfiguration[CSL] ) 
		if ( sectionTypes [ sectionsConfiguration[CSL][sect] ].type == whatType && sectionTypes [ sectionsConfiguration[CSL][sect] ].behavior != SECT_BEHAVIOR_FIXED ) rotatesCount++;

	if ( rotatesCount == 0 ) return;
	if ( rotatesCount > 1 ) skipSetHint = true;

	for ( var sect in sectionsConfiguration[CSL] ) 
		if ( sectionTypes [ sectionsConfiguration[CSL][sect] ].type == whatType && sectionTypes [ sectionsConfiguration[CSL][sect] ].behavior != SECT_BEHAVIOR_FIXED ) rotateSection(sect);

	skipSetHint = false;
}

function rotateSection(whatSect)
{	
	var whatSection = parseInt(whatSect);
	var currentSection = sectionsConfiguration[CSL][whatSection];
	
	if ( sectionTypes[currentSection].behavior == SECT_BEHAVIOR_FIXED ) 
		{
			if ( !skipSetHint ) setupHint(sectionTypes[currentSection].title);
			return;
		}
	
	var currentSectionType = sectionTypes[currentSection].type;
	var nextSection = -1;
	var isThereAnyWireless = (battery.AppleMouse > 1 || battery.AppleKeyboard > 1);
	switch ( currentSection ) 
		{
			case 00: //is processor dual or single
				nextSection = processor.Count == 2 ? 01 : 03; 
				break;
			case 19:
			case 20:
			case 21:
				if ( battery.Status == bUNKNOWN )	nextSection = isThereAnyWireless ? 21 : 18;
				else	nextSection = isThereAnyWireless ? currentSection+1 : ( currentSection == 20 ? 18 : currentSection+1 );
				break;
			case 22:
				if ( battery.Status == bUNKNOWN && battery.AppleKeyboard < 1 ) nextSection = 20;
				else nextSection = currentSection+1;			
			case 23:
				if ( battery.Status == bUNKNOWN && battery.AppleMouse < 1 ) nextSection = 21;
				else nextSection = currentSection+1;
			default:
				nextSection = currentSection+1;
				break;
		
		}
	
	if ( nextSection > sectionTypes.length-1 || currentSectionType != sectionTypes[nextSection].type || sectionTypes[nextSection].behavior == SECT_BEHAVIOR_FIXED )
		{ nextSection = getFirstSectionIdForType( currentSectionType ); }

	changeOneSection(whatSection+1, nextSection );
	updateNeed[ sectionTypes[sectionsConfiguration[CSL][whatSection]].type ] = true;


	switch ( nextSection )
		{
			case 11:
				if ( ++currentSummaryDisk[whatSection] > disksCount-1 ) currentSummaryDisk[whatSection] = 0;
				if ( !skipSetHint ) setupHint(storage[currentSummaryDisk[whatSection] ].Label);
				setOption('section-extra'+(whatSection+1),currentSummaryDisk[whatSection]);
				break;
			default:
				if ( !skipSetHint ) setupHint( sectionTypes[nextSection].title );
		}
		 
	drawInfo();			

	setOption('section'+(whatSection+1)+'at'+CSL, nextSection);
	updateSectionSelects(whatSection+1, nextSection);
}

function getFirstSectionIdForType(type)
{
	if ( type == 'battery' && battery.Status == bUNKNOWN && battery.AppleMouse )
		return 22;
	else if ( type == 'battery' && battery.Status == bUNKNOWN && battery.AppleKeyboard )
		return 23;
		
	for(var t in sectionTypes)
		if ( sectionTypes[t].type == type ) return sectionTypes[t].id;
}


function setCurrentLayout(layout)
{
	CSL = layout-1;
	
	setOption('layout',CSL);
	
	o('sectionsLayout1').style.background = (CSL==0) ? '#74A85B' : '#333';
	o('sectionsLayout2').style.background = (CSL==1) ? '#74A85B' : '#333';	
	
	updateSectionSelects(-1,0); //all
	
	updateNeed['processor'] = true;
	updateNeed['memory'] = true;
	updateNeed['storage'] = true;
	updateNeed['sensors'] = true;
	updateNeed['network'] = true;
	updateNeed['battery'] = true;	
	drawInfo();
}

function rotateLayouts()
{
	if ( CSL == 0 ) setCurrentLayout(2);
	else setCurrentLayout(1);
	
	renderLayoutNumbers(CSL+1);	
}

function takeProcessesList(list)
{
	if ( isProcessesSheetShown || !drawProcessesTableOnce )
	{
		var c = 0;
		for(var i=0; i<list.length && c<4; i++ )
		{
			var item = list[i];
			var name = item[0];
			
			var sortKey = getOption('processes-list-sort');
			var pathToIcon = miniStatCore.pathToAppIconForPID_(item[2]);
			
			if ( pathToIcon && pathToIcon != 'x' )
				{
					o('procIcon'+(c+1)).src = pathToIcon;
					o('procName'+(c+1)).style.left = "0px";
				}
			else
				{
					if ( sortKey == 'm' ) continue;	
										 
					o('procIcon'+(c+1)).src = 'Images/transparent.png';
					o('procName'+(c+1)).style.left = "-13px";				
				}	
			
			var usage = 0;
			if ( sortKey == 'm' )
			 {
				usage = d(item[3]/1024);
				o('procPerc'+(c+1)).innerText = usage+"M";				 
			 }
			else
			 {
				 usage = ( item[1] > 9.99 ) ? d(item[1]) : getOneAfterDot(item[1]);
				 if ( usage > 99 ) usage = 99;
				 o('procPerc'+(c+1)).innerText = usage+"%";				 
			 }
			 
			o('procName'+(c+1)).innerHTML = name.replace(/\s/g,'&nbsp;');
		
			c++;

		}
		drawProcessesTableOnce = true;
	}
	else
	{
		var iconIndex = 1;
		for(var i=0; i<list.length; i++) 
		{
			if ( iconIndex >= 4 ) { i=10000; continue; }
			
			var pathToIcon = miniStatCore.pathToAppIconForPID_(list[i][2]);
			if ( pathToIcon && pathToIcon != 'x' )
				{
					o('activeAppIcon'+iconIndex).src = pathToIcon;
					iconIndex++;
				}
		}
		if ( iconIndex < 4 )
		{
			for(var x=iconIndex;x<4;x++)
			{
				o('activeAppIcon'+x).src = 'Icons/nonameappicon.png';
			}
		
		}
	}
}